Index: trunk/kernel/mm/kmem.c
===================================================================
--- trunk/kernel/mm/kmem.c	(revision 690)
+++ trunk/kernel/mm/kmem.c	(revision 1)
@@ -2,5 +2,7 @@
  * kmem.c - kernel memory allocator implementation.
  *
- * Authors  Alain Greiner     (2016,2017,2018,2019,2020)
+ * Authors  Ghassan Almaless (2008,2009,2010,2011,2012)
+ *          Mohamed Lamine Karaoui (2015)
+ *          Alain Greiner (2016)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -22,191 +24,207 @@
  */
 
-#include <kernel_config.h>
-#include <hal_kernel_types.h>
+#include <almos_config.h>
+#include <hal_types.h>
 #include <hal_special.h>
 #include <printk.h>
+#include <spinlock.h>
+#include <readlock.h>
+#include <memcpy.h>
+#include <khm.h>
+#include <ppm.h>
+#include <page.h>
 #include <cluster.h>
 #include <thread.h>
-#include <memcpy.h>
-#include <ppm.h>
-#include <kcm.h>
-#include <page.h>
+#include <process.h>
+#include <device.h>
+#include <mapper.h>
+#include <vfs.h>
+#include <fatfs.h>
+#include <ramfs.h>
+#include <remote_sem.h>
+#include <remote_barrier.h>
+#include <mapper.h>
+#include <grdxt.h>
+#include <vseg.h>
 #include <kmem.h>
 
-///////////////////////////////////
-void * kmem_alloc( uint32_t  order,
-                   uint32_t  flags )
-{
-
-#if DEBUG_KMEM || DEBUG_KMEM_ERROR
-thread_t * this  = CURRENT_THREAD;
-uint32_t   cycle = (uint32_t)hal_get_cycles();
-#endif
-
-	if( order >= CONFIG_PPM_PAGE_ORDER )     // use PPM
+/////////////////////////////////////////////////////////////////////////////////////////////
+// This global array is indexed by the Kernel Memory Object Type (defined in kmem.h)
+// It contains the size of fixed size objects type dynamically allocated by the KCMs.
+// This array should be consistent with the enum defined kmem.h.
+/////////////////////////////////////////////////////////////////////////////////////////////
+
+uint32_t  kmem_size_tbl[KMEM_TYPES_NR] =
+{
+    0,                        // 0  KMEM_PAGE is not a fixed size object
+    0,                        // 1  KMEM_GENERIC   
+    sizeof( kcm_t ),          // 2  KMEM_KCM
+    sizeof( vseg_t ),         // 3  KMEM_VSEG
+    sizeof( device_t ),       // 4  KMEM_DEVICE
+    sizeof( mapper_t ),       // 5  KMEM_MAPPER
+    sizeof( process_t ),      // 6  KMEM_PROCESS
+    0,                        // 7 
+    0,                        // 8  
+    0,                        // 9  
+
+    sizeof( fatfs_inode_t ),  // 10 KMEM_FATFS_INODE
+    sizeof( fatfs_ctx_t ),    // 11 KMEM_FATFS_CTX
+    sizeof( ramfs_inode_t ),  // 12 KMEM_RAMFS_INODE
+    sizeof( ramfs_ctx_t ),    // 13 KMEM_RAMFS_CTX
+    sizeof( vfs_ctx_t ),      // 14 KMEM_VFS_CTX
+    sizeof( vfs_inode_t ),    // 15 KMEM_VFS_INODE
+    sizeof( vfs_dentry_t ),   // 16 KMEM_VFS_DENTRY
+    sizeof( vfs_file_t ),     // 17 KMEM_VFS_FILE
+    sizeof( remote_sem_t ),   // 18 KMEM_SEM
+    0,                        // 19 
+
+    64,                       // 20 KMEM_64_BYTES
+    128,                      // 21 KMEM_128_BYTES
+    256,                      // 22 KMEM_256_BYTES
+    512,                      // 23 KMEM_512_BYTES
+    1024,                     // 24 KMEM_1024_BYTES
+    2048,                     // 25 KMEM_2048_BYTES
+};
+
+/////////////////////////////////////////////////////////////////////////////////////////////
+// This static function dynamically allocates and initializes a specific KCM allocator.
+// It uses the KCM allocator embedded in cluster manager, initialized by cluster_init().
+/////////////////////////////////////////////////////////////////////////////////////////////
+static error_t kmem_get_kcm( uint32_t type )
+{
+	kcm_t    * kcm;
+	error_t    error;
+
+    // check kmem object type
+    if( (type < 2) || (type >= KMEM_TYPES_NR) )
+    {
+        printk("\n[PANIC] in %s illegal request type\n", __FUNCTION__ );
+        hal_core_sleep();
+    }
+
+    cluster_t * cluster = LOCAL_CLUSTER;
+
+    // allocates memory for the requested KCM allocator
+	kcm = kcm_alloc( &cluster->kcm );
+	if( kcm == NULL )
+    {
+		printk("\n[ERROR] in %s : failed to create KCM type %d in cluster %x\n",
+               __FUNCTION__ , type , local_cxy );
+        return ENOMEM;
+    }
+
+    // initializes the new KCM allocator 
+	error = kcm_init( kcm , type );
+
+	if( error )
 	{
-		// allocate memory from PPM
-		page_t * page = (void *)ppm_alloc_pages( order - CONFIG_PPM_PAGE_ORDER );
-
-		if( page == NULL )
-		{
-
-#if DEBUG_KMEM_ERROR
-if (DEBUG_KMEM_ERROR < cycle)
-printk("\n[ERROR] in %s : thread[%x,%x] failed for PPM / order %d / cluster %x / cycle %d\n",
-__FUNCTION__ , this->process->pid , this->trdid , order , local_cxy , cycle );
-#endif
-			return NULL;
-		}
-
-		// reset page if requested
-		if( flags & AF_ZERO ) page_zero( page );
-
-        // get pointer on buffer from the page descriptor
-        xptr_t page_xp = XPTR( local_cxy , page );
-        void * ptr     = GET_PTR( ppm_page2base( page_xp ) );
-
-#if DEBUG_KMEM
-if( (DEBUG_KMEM < cycle) && (DEBUG_KMEM_CXY == local_cxy) && (DEBUG_KMEM_ORDER == order) )
-printk("\n[%s] thread[%x,%x] from PPM / order %d / ppn %x / cxy %x / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid,
-order, ppm_page2ppn(XPTR(local_cxy,ptr)), local_cxy, cycle );
-#endif
-        return ptr;
-	}
-	else                                     // use KCM 
+		printk("\n[ERROR] in %s : failed to init KCM type %d\n",
+               __FUNCTION__ , type , local_cxy );
+		return error;
+	}
+
+	cluster->kcm_tbl[type] = kcm;
+	hal_wbflush();
+
+	return 0;
+}
+ 
+
+/////////////////////////////////////
+void * kmem_alloc( kmem_req_t * req )
+{
+	cluster_t * cluster = LOCAL_CLUSTER;
+
+	uint32_t    type;
+	uint32_t    size;    // ln( pages ) if PPM / bytes if KHM or BKM / unused if KCM
+	uint32_t    flags;
+	void      * ptr;     // local pointer on allocated memory buffer
+
+	type  = req->type;
+	size  = req->size;
+	flags = req->flags;
+  
+	kmem_dmsg("\n[INFO] %s in cluster %x : type %d, size %d, flags %x at cycle %d \n",
+		      __FUNCTION__, local_cxy , type, size, flags , hal_time_stamp() );
+
+	if( type >= KMEM_TYPES_NR )
+    {
+        printk("\n[PANIC] in %s illegal request type\n", __FUNCTION__ );
+        hal_core_sleep();
+    }
+  
+    // analyse request type
+	if( type ==  KMEM_PAGE )                       // PPM allocator
+    {        
+        // allocate the number of requested pages
+		ptr = (void*)ppm_alloc_pages( size );
+
+        // reset page if required
+		if( flags & AF_ZERO ) page_zero( (page_t*)ptr );
+	}
+    else if( type == KMEM_GENERIC )                // KHM allocator
+    {
+        // allocate memory from KHM
+		ptr = khm_alloc( &cluster->khm , size );
+
+        // reset memory if requested
+		if( flags & AF_ZERO ) memset( ptr , 0 , size );
+	}
+    else                                           // KCM allocator
+    {
+        uint32_t error = 0;
+
+        // initialize the KCM allocator if not already done
+	    if( cluster->kcm_tbl[type] == NULL )
+	    { 
+            spinlock_lock( &cluster->kcm_lock );
+			error = kmem_get_kcm( type );
+            spinlock_unlock( &cluster->kcm_lock );
+	    }
+
+        // allocate memory from KCM if success
+        if( error ) ptr = NULL;
+        else        ptr = kcm_alloc( cluster->kcm_tbl[type] );
+	}
+
+    if( ptr == NULL )
+    {
+	    printk("\n[ERROR] in %s : failed for type %d, size %d, flags %x in cluster %x\n", 
+	       __FUNCTION__ , type , size , flags , local_cxy );
+ 
+	    return NULL;
+    }
+
+	kmem_dmsg("\n[INFO] %s got ptr = %x in cluster %x at cycle %d\n",
+		  __FUNCTION__, (intptr_t)ptr , local_cxy , hal_time_stamp() );
+	    
+	return ptr;
+
+} // end kmem_alloc()
+
+//////////////////////////////////
+void kmem_free( kmem_req_t * req )
+{
+	if( req->type >= KMEM_TYPES_NR )
+    {
+        printk("\n[PANIC] in %s : illegal request type\n", __FUNCTION__ );
+        hal_core_sleep();
+    }
+  
+	switch(req->type)
 	{
-		// allocate memory from KCM
-		void * ptr = kcm_alloc( order );
-
-		if( ptr == NULL )
-		{
-
-#if DEBUG_KMEM_ERROR
-if (DEBUG_KMEM_ERROR < cycle)
-printk("\n[ERROR] in %s : thread[%x,%x] failed for KCM / order %d / cluster %x / cycle %d\n",
-__FUNCTION__ , this->process->pid , this->trdid , order , local_cxy , cycle );
-#endif
-			return NULL;
-		}
-
-		// reset memory if requested
-		if( flags & AF_ZERO ) memset( ptr , 0 , 1<<order );
-
-#if DEBUG_KMEM
-if( (DEBUG_KMEM < cycle) && (DEBUG_KMEM_CXY == local_cxy) && (DEBUG_KMEM_ORDER == order) )
-printk("\n[%s] thread [%x,%x] from KCM / order %d / base %x / cxy %x / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid,
-order, ptr, local_cxy, cycle ); 
-#endif
-        return ptr;
-	}
-}  // end kmem_alloc()
-
-//////////////////////////////
-void kmem_free( void    * ptr,
-                uint32_t  order )
-{
-	if( order >= CONFIG_PPM_PAGE_ORDER )     // use PPM
-	{
-        page_t * page = GET_PTR( ppm_base2page( XPTR( local_cxy , ptr ) ) );
-
-        ppm_free_pages( page );
-    }
-	else                                     // use KCM 
-    {
-        kcm_free( ptr , order );
-	}
-}  // end kmem_free()
-
-
-
-////////////////////////////////////////
-void * kmem_remote_alloc( cxy_t     cxy,
-                          uint32_t  order,
-                          uint32_t  flags )
-{
-
-#if DEBUG_KMEM || DEBUG_KMEM_ERROR
-thread_t * this = CURRENT_THREAD;
-uint32_t   cycle = (uint32_t)hal_get_cycles();
-#endif
-
-	if( order >= CONFIG_PPM_PAGE_ORDER )     // use PPM
-	{
-		// allocate memory from PPM
-		xptr_t page_xp = ppm_remote_alloc_pages( cxy , order - CONFIG_PPM_PAGE_ORDER );
-
-		if( page_xp == XPTR_NULL )
-		{
-
-#if DEBUG_KMEM_ERROR
-if( DEBUG_KMEM_ERROR < cycle )
-printk("\n[ERROR] in %s : thread[%x,%x] failed for PPM / order %d / cluster %x / cycle %d\n",
-__FUNCTION__ , this->process->pid , this->trdid , order , cxy , cycle );
-#endif
-			return NULL;
-		}
-
-        // get extended pointer on remote buffer
-        xptr_t base_xp = ppm_page2base( page_xp );
-
-		// reset memory if requested
-		if( flags & AF_ZERO ) hal_remote_memset( base_xp , 0 , 1<<order );
-
-#if DEBUG_KMEM
-if( (DEBUG_KMEM < cycle) && (DEBUG_KMEM_CXY == local_cxy) && (DEBUG_KMEM_ORDER == order) )
-printk("\n[%s] thread[%x,%x] from PPM / order %d / ppn %x / cxy %x / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid,
-order, ppm_page2ppn( page_xp ), cxy, cycle );
-#endif
-        return GET_PTR( base_xp );
-	}
-	else                                     // use KCM 
-	{
-		// allocate memory from KCM
-		void * ptr = kcm_remote_alloc( cxy , order );
-
-		if( ptr == NULL )
-		{
-
-#if DEBUG_KMEM_ERROR
-if( DEBUG_KMEM_ERROR < cycle )
-printk("\n[ERROR] in %s : thread[%x,%x] failed for KCM / order %d / cluster %x / cycle %d\n",
-__FUNCTION__ , this->process->pid , this->trdid , order , cxy , cycle );
-#endif
-			return NULL;
-		}
-
-		// reset memory if requested
-		if( flags & AF_ZERO )  hal_remote_memset( XPTR( cxy , ptr ) , 0 , 1<<order );
-
-#if DEBUG_KMEM
-if( (DEBUG_KMEM < cycle) && (DEBUG_KMEM_CXY == local_cxy) && (DEBUG_KMEM_ORDER == order) )
-printk("\n[%s] thread [%x,%x] from KCM / order %d / base %x / cxy %x / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid,
-order, ptr, cxy, cycle );
-#endif
-        return ptr;
-	}
-}  // kmem_remote_malloc()
-
-/////////////////////////////////////
-void kmem_remote_free( cxy_t     cxy,
-                       void    * ptr,
-                       uint32_t  order )
-{
-	if( order >= CONFIG_PPM_PAGE_ORDER )     // use PPM
-	{
-        page_t * page = GET_PTR( ppm_base2page( XPTR( cxy , ptr ) ) );
-
-        ppm_remote_free_pages( cxy , page );
-    }
-	else                                     // use KCM 
-    {
-        kcm_remote_free( cxy , ptr , order );
-	}
-}  // end kmem_remote_free()
-
-
-
+	    case KMEM_PAGE:
+		ppm_free_pages( (page_t*)req->ptr );
+		return;
+
+	    case KMEM_GENERIC:
+	    khm_free( req->ptr );
+		return;
+
+	    default:
+		kcm_free( req->ptr );
+		return;
+	}
+}
+
+
Index: trunk/kernel/mm/kmem.h
===================================================================
--- trunk/kernel/mm/kmem.h	(revision 690)
+++ trunk/kernel/mm/kmem.h	(revision 1)
@@ -1,6 +1,8 @@
 /*
- * kmem.h - unified kernel memory allocator definition
+ * kmem.h - kernel unified memory allocator interface
  *
- * Authors  Alain Greiner     (2016,2017,2018,2019,2020)
+ * Authors  Ghassan Almaless (2008,2009,2010,2011,2012)
+ *          Mohamed Lamine Karaoui (2015)
+ *          Alain Greiner (2016)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -25,60 +27,90 @@
 #define _KMEM_H_
 
-#include <hal_kernel_types.h>
+#include <hal_types.h>
 #include <kcm.h>
 
 /*************************************************************************************
- * This defines the generic Allocation Flags that can be associated to
+ * This enum defines the Kernel Memory Types for dynamically allocated objects.
+ ************************************************************************************/
+
+enum
+{
+  KMEM_PAGE             = 0,   /*! reserved for PPM allocator                       */
+  KMEM_GENERIC          = 1,   /*! reserved for KHM allocator                       */
+  KMEM_KCM              = 2,   /*! kcm_t                                            */
+  KMEM_VSEG             = 3,   /*! vseg_t                                           */
+  KMEM_DEVICE           = 4,   /*! device_t                                         */
+  KMEM_MAPPER           = 5,   /*! mapper_t                                         */
+  KMEM_PROCESS          = 6,   /*! process_t                                        */
+  KMEM_TBD_7            = 7,
+  KMEM_TBD_8            = 8,
+  KMEM_TBD_9            = 9,
+
+  KMEM_FATFS_INODE      = 10,  /*! fatfs_inode_t                                    */
+  KMEM_FATFS_CTX        = 11,  /*! fatfs_ctx_t                                      */
+  KMEM_RAMFS_INODE      = 12,  /*  ramfs_inode_t                                    */
+  KMEM_RAMFS_CTX        = 13,  /*! ramfs_ctx_t                                      */
+  KMEM_VFS_CTX          = 14,  /*! vfs_context_t                                    */
+  KMEM_VFS_INODE        = 15,  /*! vfs_inode_t                                      */
+  KMEM_VFS_DENTRY       = 16,  /*! vfs_dentry_t                                     */
+  KMEM_VFS_FILE         = 17,  /*! vfs_file_t                                       */
+  KMEM_SEM              = 18,  /*! remote_sem_t                                     */
+  KMEM_TBD_19           = 19,
+
+  KMEM_64_BYTES         = 20,  /*! fixed size buffer                                */
+  KMEM_128_BYTES        = 21,  /*! fixed size buffer                                */
+  KMEM_256_BYTES        = 22,  /*! fixed size buffer                                */
+  KMEM_512_BYTES        = 23,  /*! fixed size buffer                                */
+  KMEM_1024_BYTES       = 24,  /*! fixed size buffer                                */
+  KMEM_2048_BYTES       = 25,  /*! fixed size buffer                                */
+
+  KMEM_TYPES_NR         = 26,
+};
+
+/*************************************************************************************
+ * This defines the generic Allocation Flags that can be associated to 
  * a Kernel Memory Request.
  ************************************************************************************/
 
 #define AF_NONE       0x0000   // no attributes
-#define AF_KERNEL     0x0001   // for kernel use ???
-#define AF_ZERO       0x0002   // data buffer must be reset to 0
+#define AF_KERNEL     0x0001   // for kernel use    
+#define AF_ZERO       0x0002   // must be reset to 0
 
 /*************************************************************************************
- * These two functions allocate physical memory in a local or remote cluster
- * as specified by the <cxy>, <order> and <flags> arguments, and return a local
- * pointer on the allocated buffer. The buffer size (in bytes) is a power of 2,
- * equal to (1 << order) bytes. It can be initialized to zero if requested.
- * Depending on the <order> value, it uses two specialised allocators:
- * - When order is larger or equal to CONFIG_PPM_PAGE_ORDER, the PPM (Physical Pages
- *   Manager) allocates 2**(order - PPM_PAGE_ORDER) contiguous small physical pages.
- *   This allocator implements the buddy algorithm.
- * - When order is smaller than CONFIG_PPM_PAGE_ORDER, the KCM (Kernel Cache Manager) 
- *   allocates an aligned block of 2**order bytes from specialised KCM[ORDER] caches
- *  (one KCM cache per block size).  
- *************************************************************************************
- * @ cxy    : [in] target cluster identifier for a remote access).
- * @ order  : [in] ln( block size in bytes).
- * @ flags  : [in] allocation flags defined above.
- * @ return local pointer on allocated buffer if success / return NULL if no memory.
+ * This structure defines a Kernel Memory Request. 
  ************************************************************************************/
-void * kmem_alloc( uint32_t  order,
-                   uint32_t  flags );
 
-void * kmem_remote_alloc( cxy_t     cxy,
-                          uint32_t  order,
-                          uint32_t  flags );
+typedef struct kmem_req_s
+{
+    uint32_t      type;   /*! request type                                          */
+    uint32_t      size;   /*! ln2(nb_pages) if PPM / bytes if KHM / unused by KCM   */
+    uint32_t      flags;  /*! request attributes                                    */
+    void        * ptr;    /*! local pointer on allocated buffer (only used by free) */
+} 
+kmem_req_t;
 
 /*************************************************************************************
- * These two functions release a previously allocated physical memory block,
- * as specified by the <cxy>, <order> and <ptr> arguments. 
- * - When order is larger or equal to CONFIG_PPM_PAGE_ORDER, the PPM (Physical Pages
- *   Manager) releases 2**(order - PPM_PAGE_ORDER) contiguous small physical pages.
- *   This allocator implements the buddy algorithm.
- * - When order is smaller than CONFIG_PPM_PAGE_ORDER, the KCM (Kernel Cache Manager)
- *   release release the block of 2**order bytes to the specialised KCM[order] cache.
+ * This generic function allocates physical memory in the local cluster
+ * as specified by the request descriptor.
+ * It uses three specialised physical memory allocators:
+ * - PPM (Physical Pages Manager) allocates N contiguous physical pages,
+ *       N must be a power of 2.
+ * - KHM (Kernel Heap Manager) allocates a physical memory buffer,
+ *       that can have any size.
+ * - KCM (Kernel Cache Manager) allocates various fixed size objects,
+ *       handling a dedicated cache for each object type.
  *************************************************************************************
- * @ cxy    : [in] target cluster identifier for a remote access.
- * @ ptr    : [in] local pointer to released block.
- * @ order  : [in] ln( block size in bytes ).
+ * @ req : local pointer to allocation request
+ * @ return a local pointer to allocated buffer / NULL otherwise
  ************************************************************************************/
-void  kmem_free( void    * ptr,
-                 uint32_t  order );
+void * kmem_alloc( kmem_req_t * req );
 
-void  kmem_remote_free( cxy_t     cxy,
-                        void    * ptr,
-                        uint32_t  order );
+/*************************************************************************************
+ * This function releases previously allocated physical memory, as specified
+ * by the "type" and "ptr" fiels of the kmem-req_t request.
+ *************************************************************************************
+ * @ req : local pointer to request descriptor.
+ ************************************************************************************/
+void  kmem_free ( kmem_req_t * req );
 
 
Index: trunk/kernel/mm/mapper.c
===================================================================
--- trunk/kernel/mm/mapper.c	(revision 690)
+++ trunk/kernel/mm/mapper.c	(revision 1)
@@ -1,7 +1,7 @@
 /*
- * mapper.c - Kernel cache for FS files or directories implementation.
+ * mapper.c - Map memory, file or device in process virtual address space.
  *
  * Authors   Mohamed Lamine Karaoui (2015)
- *           Alain Greiner          (2016,2017,2018,2019,2020)
+ *           Alain Greiner (2016)
  *
  * Copyright (c)  UPMC Sorbonne Universites
@@ -23,14 +23,10 @@
  */
 
-#include <kernel_config.h>
-#include <hal_kernel_types.h>
+#include <almos_config.h>
+#include <hal_types.h>
 #include <hal_special.h>
-#include <hal_uspace.h>
-#include <hal_vmm.h>
 #include <grdxt.h>
-#include <string.h>
 #include <rwlock.h>
 #include <printk.h>
-#include <memcpy.h>
 #include <thread.h>
 #include <core.h>
@@ -38,91 +34,81 @@
 #include <kmem.h>
 #include <kcm.h>
-#include <ppm.h>
 #include <page.h>
 #include <cluster.h>
 #include <vfs.h>
 #include <mapper.h>
-#include <dev_ioc.h>
-
-
-/////////////////////////////////////
-xptr_t  mapper_create( cxy_t     cxy,
-                       uint32_t  type )
-{
-    mapper_t * mapper_ptr;
+
+//////////////////////////
+mapper_t * mapper_create()
+{
+    mapper_t * mapper;
+    kmem_req_t req;
     error_t    error;
 
-    // allocate memory for mapper descriptor
-    mapper_ptr  = kmem_remote_alloc( cxy , bits_log2(sizeof(mapper_t)) , AF_ZERO );
-
-    if( mapper_ptr == NULL )
-    {
-
-#if DEBUG_MAPPER_ERROR 
-printk("\n[ERROR] in %s : no memory for mapper descriptor\n", __FUNCTION__ );
-#endif
-        return XPTR_NULL;
-    }
-
-    // initialize refcount and type
-    hal_remote_s32( XPTR( cxy , &mapper_ptr->refcount ) , 0 );
-    hal_remote_s32( XPTR( cxy , &mapper_ptr->fs_type )  , type );
+    // allocate memory for associated mapper
+	req.type  = KMEM_MAPPER;
+	req.size  = sizeof(mapper_t);
+    req.flags = AF_KERNEL | AF_ZERO;
+	mapper    = (mapper_t *)kmem_alloc( &req );
+
+    if( mapper == NULL )
+    {
+        printk("\n[ERROR] in %s : no memory for mapper descriptor\n", __FUNCTION__ );
+        return NULL;
+    }
+
+    // initialize refcount & inode
+	mapper->refcount = 0;
+    mapper->inode    = NULL;
 
     // initialize radix tree
-    error = grdxt_remote_init( XPTR( cxy , &mapper_ptr->rt ),
-                               CONFIG_MAPPER_GRDXT_W1,
-                               CONFIG_MAPPER_GRDXT_W2,
-                               CONFIG_MAPPER_GRDXT_W3 );
+	error = grdxt_init( &mapper->radix,
+                        CONFIG_VMM_GRDXT_W1,
+                        CONFIG_VMM_GRDXT_W2,
+                        CONFIG_VMM_GRDXT_W3 );
+
     if( error )
     {
-
-#if DEBUG_MAPPER_ERROR 
-printk("\n[ERROR] in %s : cannot initialize radix tree\n", __FUNCTION__ );
-kmem_remote_free( cxy , mapper_ptr , bits_log2(sizeof(mapper_t)) );
-#endif
-        return XPTR_NULL;
+        printk("\n[ERROR] in %s : cannot initialize radix tree\n", __FUNCTION__ );
+	    req.type  = KMEM_MAPPER;
+        req.ptr   = mapper;
+        kmem_free( &req );
+        return NULL;
     }
 
     // initialize mapper lock
-    remote_rwlock_init( XPTR( cxy , &mapper_ptr->lock ) , LOCK_MAPPER_STATE );
+	rwlock_init(  &mapper->lock );
 
     // initialize waiting threads xlist (empty)
-    xlist_root_init( XPTR( cxy , &mapper_ptr->wait_root ) );
+	xlist_root_init( XPTR( local_cxy , &mapper->wait_root ) );
 
     // initialize vsegs xlist (empty)
-    xlist_root_init( XPTR( cxy , &mapper_ptr->vsegs_root ) );
-
-    return XPTR( cxy , mapper_ptr );
-
-}  // end mapper_create()
-
-////////////////////////////////////////
-void mapper_destroy( xptr_t  mapper_xp )
-{
-    xptr_t     page_xp;
+	xlist_root_init( XPTR( local_cxy , &mapper->vsegs_root ) );
+
+    return mapper;
+
+} // end mapper_create()
+
+///////////////////////////////////////////
+error_t mapper_destroy( mapper_t * mapper )
+{
     page_t   * page;
     uint32_t   found_index = 0;
     uint32_t   start_index = 0;
-
-    cxy_t      mapper_cxy = GET_CXY( mapper_xp ); 
-    mapper_t * mapper_ptr = GET_PTR( mapper_xp );
-
-    // build extended pointer on radix tree
-    xptr_t rt_xp = XPTR( mapper_cxy , &mapper_ptr->rt );
-
-    // scan radix tree
+    kmem_req_t req;
+    error_t    error;
+
+    // scan radix three and release all registered pages to PPM
     do
     {
         // get page from radix tree
-        page_xp = grdxt_remote_get_first( rt_xp,
-                                          start_index , 
-                                          &found_index );
-        page = GET_PTR( page_xp );
-        
-        // release registered pages to PPM
-        if( page != NULL )
+        page = (page_t *)grdxt_get_first( &mapper->radix , start_index , &found_index );
+
+        if( page != NULL ) 
         {
             // remove page from mapper and release to PPM
-            mapper_remote_release_page( mapper_xp , page );
+	        error = mapper_release_page( mapper , found_index , page );
+
+            if ( error ) return error;
 
             // update start_key value for next page
